{% autoescape None %}
{
    class AND {
        constructor(exps) {
            this.and = exps;
        }
        not() {
            return new OR(this.and.map(function (x) { return x.not();}));
        }
        {% if debug %}toString() {
            return "(" + this.and.map(function (x) { return x.toString();}).join(" AND ") + ")";
        }{% end %}
    }

    class OR {
        constructor(exps) {
            this.or = exps;
        }
        not() {
            return new AND(this.or.map(function (x) { return x.not();}));
        }
        {% if debug %}toString() {
            return "(" + this.or.map(function (x) { return x.toString();}).join(" OR ") + ")";
        }{% end %}
    }

    class Relation {
        constructor(node, verb, value) {
            this.node = node;
            this.verb = verb;
            this.value = value.slice(1, -1); // remove simple quote
            this.neg = false;
        }
        not() {
            this.neg = ! this.neg;
            return this;
        }
    }

    class Attribute {
        constructor(node, key, verb, value) {
            this.node = node;
            this.key = key;
            this.verb = verb;
            this.value = value.slice(1, -1); // remove simple quote
            this.neg = false;
        }
        not() {
            this.neg = ! this.neg;
            return this;
        }
    }
}

start = logical_or: logical_or {
    {% if debug %}console.log(logical_or.toString()){% end %}
    return logical_or;
}


logical_or = left:logical_and _ "OR" _ right:logical_or {
        return new OR([left, right]);
} / logical_and

logical_and = left:expression _ "AND" _ right:logical_and {
        return new AND([left, right]);
} / expression

expression = "NOT" _ operand:expression {
        return operand.not();
} / primary

primary = lparenthesis _ logical_or:(logical_or) _ rparenthesis {
        return logical_or;
} / assertion

lparenthesis "parenthesis '('" = "("
rparenthesis "parenthesis ')'" = ")"

assertion = rules

_ "whitespace" = [ \t\n\r]* {
    return " ";
}

rules = {% for idx, rule in enumerate(rules) %}
{% if idx %}/ {% end %} node:"{{ rule[0] }}" _ verb:"{{ rule[1] }}" _ dest:{{ rule[2].lower() }} {
    return new Relation(node, verb, dest);
} / node:"{{ rule[0] }}" _ verb:"{{ rule[1] }}" _ op:("ALL" / "ANY") "(" _ head:{{ rule[2].lower() }} _ tail:("," _ {{ rule[2].lower() }} )* _ ")" {
    let dests = tail.reduce(function(result, element) {
        result.push(element[2])
        return result;
    }, [head]);
    dests = dests.map(function (x) {return new Relation(node, verb, x);})
    if (op == "ALL") {
        return new AND(dests);
    } else {
        return new OR(dests);
    }
} / node:"{{ rule[0] }}" "." key:{{ rule[0].lower() }}_keys _ verb:("=" / "!=") _ value:value {
	return new Attribute(node, key, verb, value);
} / node:"{{ rule[0] }}" "." key:{{ rule[0].lower() }}_keys _ verb:("IN") _ "ANY" "(" _ head:value _ tail:("," _ value )* _ ")" {
    let dests = tail.reduce(function(result, element) {
        result.push(element[2])
        return result;
    }, [head]);
    dests = dests.map(function (x) {return new Attribute(node, key, "=", x);})
    return new OR(dests);
}
{% end %}

{% for node, values in srcs.items() %}
{{ node.lower() }}_keys = val:({{ " / ".join(map(lambda x: "\"{}\"".format(x), values)) }}) {
    return val;
}{% end %}

value "value" = ("'"[^']*"'") {
    return text();
}

{% for node, values in dests.items() %}
{{ node.lower() }} = val:({{ " / ".join(map(lambda x: "\"'{}'\"".format(x), values)) }}) {
    return val;
}{% end %}
